package com.sensorsdata.analytics.android.sdk;

import android.content.SharedPreferences;
import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.concurrent.Future;

/**
 * 持久化存储一些公共的根部字段
 *
 * @author MUTOU
 * @date 2018/11/26 16:11
 */
class PersistentRootFields extends PersistentIdentity<JSONObject> {

    PersistentRootFields(Future<SharedPreferences> loadStoredPreferences) {
        super(loadStoredPreferences, "root_fields", new PersistentSerializer<JSONObject>() {
            @Override
            public JSONObject load(String value) {
                try {
                    return new JSONObject(value);
                } catch (JSONException e) {
                    Log.e("Persistent", "failed to load root fields from SharedPreferences.", e);
                    return null;
                }
            }

            @Override
            public String save(JSONObject item) {
                return item.toString();
            }

            @Override
            public JSONObject create() {
                return new JSONObject();
            }
        });
    }
}
